namespace CMSMicroservice.Application.ProductTagCQ.Commands.UpdateProductTag;
public class UpdateProductTagCommandValidator : AbstractValidator<UpdateProductTagCommand>
{
    public UpdateProductTagCommandValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.TagId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateProductTagCommand>.CreateWithOptions((UpdateProductTagCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
